/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *  
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *  
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#ifndef _NMM_CHANNELCONFIG_HPP_
#define _NMM_CHANNELCONFIG_HPP_

#include "nmm/nmm_prefix.hpp"

#include <vector>
#include <string>

using namespace std;

namespace NMM {
  struct Channel {
    char name[32];
    char frequency[30];
 };

 class ChannelConfig {
   vector<Channel> config;

   void transform(string &s){
     for (unsigned int i = 0; i <= s.length(); i++)
       s[i] = toupper(s[i]);
   }
   
   bool compare(string s1, string s2);
   
   string aliasFilename;
   
   void readDVBChannels(string file);
   void readIVTVChannels(string file);
   
 public:
   
   enum mode_e {DVB=0, IVTV};
   
   ChannelConfig();
   ChannelConfig& load(mode_e, string file = "");
   int size() const {return config.size();}
   char* getChannelName(const int i) {return config[i-1].name;}
   Channel getChannel(int i) const {return config[i];}
   unsigned int getChannelNumber(string ch);
 };
  
}

#include "nmm/nmm_suffix.hpp"

#endif
